<!DOCTYPE html>
<?php
include '../../etc/asceds.php';
include '../../etc/config.php';
include '../../etc/users.php';
$username = $_SERVER['REMOTE_USER'];
$servername = $_SERVER['SERVER_NAME'];
if (in_array('ALL', $authdomains[$username])) {
   $domains = $allauthdomains ;
} else {  
   $domains = $authdomains[$username];
} 
?>

<html>
  <head>
    <meta name="author" content="Florin Manolache">
    <title>ASCEDS Certificate propagate @ <?php echo $unit; ?></title>
    <link rel="stylesheet" href="../css/cert.css">
  </head>

<body>

<?php
include '../header.php';
?>

<div id="main">

<article>
<?php
include 'navi.php';
?>

<p class="asceds">ASCEDS certificate propagate</p> 

<?php
include '../custom.php';
?>

<?php
echo "<p> Hello user " . $username . " </p>";
#print_r($domains);

# initialize infotodo variables
$infotodo = '';
$infotodo2 = '';

# first checks and filtering of input
$validinput = 'yes';

$ack = strtolower ( trim($_POST["ack"]) );
# tests and filters for hostname
$ack_00 = preg_replace( '/[^a-z0-9]/', '', $ack );
if( $ack_00 != $ack ) {
   echo '<br>Invalid characters in acknowledgement <br>';
   $validinput='';
   $ack = $ack_00;
} elseif( empty($ack) ) {
   echo '<br> Empty acknowledgement <br>';
   $validinput='';
}

$hostname = strtolower ( trim($_POST["hostname"]) );
# tests and filters for hostname
$hostname_00 = preg_replace( '/[^-.a-z0-9]/', '', $hostname );
if( $hostname_00 != $hostname ) {
   echo '<br>Invalid characters in host <br>';
   $validinput='';
   $hostname = $hostname_00;
} elseif( empty($hostname) ) {
   echo '<br> Empty host entry <br>';
   $validinput='';
}

$domain = strtolower ( trim($_POST["domain"]) );
# tests and filters for domain
$domain_00 = preg_replace( '/[^-.a-z0-9]/', '', $domain );
if( $domain_00 != $domain ) {
   echo '<br>Invalid characters in domain <br>';
   $validinput='';
   $domain = $domain_00;
} elseif( empty($domain) ) {
   echo '<br> Empty domain entry <br>';
   $validinput='';
} elseif( ! in_array($domain, $domains) ) {
   echo '<br> User ' . $username . ' is not authorized for domain ';
   echo $domain . '  <br>';
   $validinput='';
}

$fullhostname = $hostname . '.' . $domain;
# tests and filters for fullhostname
if(! filter_var($fullhostname, FILTER_VALIDATE_DOMAIN, FILTER_FLAG_HOSTNAME)) {
   echo '<br> Invalid full hostname format detected <br>';
   $validinput='';
}

$sans = strtolower ( trim($_POST["sans"]) );
# tests and filters for sans
if( ! empty($sans) ) {
   $sans_00 = preg_replace( '/[^-. ,a-z0-9]/', '', $sans );
   if( $sans_00 != $sans ) {
      echo '<br>Invalid characters in SANs <br>';
      $validinput='';
      $sans = $sans_00;
   }
} 

if( ! empty($validinput)) {

   echo '<p>';
   echo 'Hostname: ' . $fullhostname . '<br>';
   echo 'Existing (old) SANs: ' . $sans . '<br>';
   echo '</p>';

   # assume there is no asceds access to the client yet
   $ascedsaccess='';
   $cmd = $sshcommand . '"' . $pathtoexec . '/asceds-test-return -c ' 
             . $fullhostname . '"';
   $rwtest = trim( shell_exec($cmd) );
   echo '<p class="solidb">Access to asceds@' . $fullhostname . ' is: ';
   echo $rwtest . '</p>'; 
   if( $rwtest == 'noaccess' ) {
      echo '<p class="bold">Network access to asceds@' . $fullhostname ;
      echo ' was denied.</p>';
      echo '<p> Please make sure that: <ul><li>the host is online;</li> ';
      echo '<li>ASCEDS was installed;</li> ';
      echo '<li>ASCEDS was initialized by running ' ;
      echo '"asceds-init -s ' . $servername . '" ' ;
      echo 'on the client ' . $fullhostname . ' as root/sudo </li></ul></p>';
      echo 'Then try again. </p>';
   } elseif( $rwtest == 'readonly' ) {              
      echo '<p class="bold">Network access to asceds@' . $fullhostname ;
      echo ' is read-only.</p>';
      echo '<p> Please allow write access and try again. </p>';
   } elseif( $rwtest == 'nocertconf' ) {
      echo '<p>Network access to asceds@' . $fullhostname ;
      echo ' is working properly. The certificate configuration file ';
      echo 'was not created. Please initialize ASCEDS on ' . $fullhostname ;
      echo ' by running "asceds-init -s ' . $servername . '" ' ;
      echo 'as root/sudo, then try again. </p>';
   } elseif( $rwtest == 'success' ) {
      echo '<p>Network access to asceds@' . $fullhostname ;
      echo ' was working properly. The certificate configuration file ';
      echo 'is available on the client.</p>';
      $ascedsaccess='yes';
   } else {
      echo '<p class="bold">Network access to asceds@' . $fullhostname ;
      echo ' cannot be tested.<br>';
      echo 'asceds-test-return bug, ';
      echo 'contact the certificate manager admins.</p>';   
   }

# this is just for bypassing the check for development purpose
# remove in the production version
#$ascedsaccess='yes';

   if( empty($ascedsaccess) ) {
      # redo the submission
      echo '<form action="asceds_cert.php" method="post">';
      echo '<input type="hidden" name="hostname" value="' . $hostname . '">';
      echo '<input type="hidden" name="ack" value="' . $ack . '">';
      echo '<input type="hidden" name="sans" value="' . $sans . '">';
      echo '<input type="hidden" name="domain" value="' . $domain . '">';
      echo '<input type="submit" value="Try Again">';
      echo ' --> <span class="bold">Please WAIT</span> ';
      echo 'for the certificate to be created and propagated ';
      echo 'after placing the request. ';
      echo 'It may take a minute or two. ';
      echo '</form>';      
      $infotodo='norwaccess';
   } else {

      # prevent race conditions
      $requestconffile = $certqueuedir . '/' . $fullhostname . '.cert';
      $revokeconffile = $certqueuedir . '/' . $fullhostname . '.rev';
      $propagateconffile = $certqueuedir . '/' . $fullhostname . '.asceds';
      if( is_file($revokeconffile) ) {
         echo '<p>A revoke request is already in the queue for ' . $fullhostname;
         echo '<br>' . nl2br( file_get_contents($revokeconffile) );
         echo '<br>A new certificate can be generated in a few minutes.</p>';
         $infotodo='lockedrequest';
      } elseif( is_file($requestconffile) ) {
         echo '<p>A new certificate request is already in the queue for ' . $fullhostname;
         echo '<br>' . nl2br( file_get_contents($requestconffile) );
         echo '<br>A new certificate can be generated in a few minutes.</p>';
         $infotodo='lockedrequest';
      } elseif( is_file($propagateconffile) ) {
         echo '<p>A propagate request is already in the queue for ' .  $fullhostname;
         echo '<br>' . nl2br( file_get_contents($propagateconffile) );
         echo '<br>Please wait until it is completed.</p>';
         $infotodo='lockedrequest';
      } else {
         $propagatefile = fopen($propagateconffile, "w") or 
                    die('Unable to open file!' . $propagateconffile); 
         $timeline = 'REQUEST_DATE="' . date("m/d/Y H:i:s") . '"
';
         $hostline = 'CLIENT_DOMAIN_NAME="' . $fullhostname . '"
';
         $requestedby = 'REQUESTED_BY="' . $username . '"
';
         $ackline = 'ACK_CHANGE_TYPE="' . $ack . '"
';
         fwrite($propagatefile, $timeline);
         fwrite($propagatefile, $hostline);
         fwrite($propagatefile, $requestedby);
         fwrite($propagatefile, $ackline); 
         fclose($propagatefile);

         if( $propagatemode == 'cron' ) {
            echo '<p> Your request was recorded and queued.<br>';
            echo 'It will be executed in less than ' . $propagatetime . '.</p>';
            $infotodo='cron';  
   
         } elseif( $propagatemode == 'ssh' ) {
            $cmd = $sshcommand . '"' . $pathtoexec . '/asceds-web-propagate -q -c ' 
                   . $fullhostname . '"';
            echo '<p class="solidb">';
            echo nl2br( shell_exec($cmd) ) . '</p>';
            $infotodo='ssh';
         } else {
            echo '<p class="bold">Unknown propagate mode "' . $propagatemode . '"</p>';
            $infotodo='badinput';
         }
      }
   }
} else {
   echo 'Page got malformed input.<br>';
   echo 'Please follow instructions on the right';
   $infotodo='badinput';
}  

?>
</article>

<aside>

<p>
The procedure for changing the certificate configuration, 
e.g. when virtual server names are added or removed in the SAN list:
<ul>
<li>Login with root/sudo rights on the client 
<?php echo $fullhostname ; ?>.</li>
<li>Run on the client (using sudo if needed):<br>
<span class="bold">asceds-sans-update</span><br>
Add or remove SAN values to suit your needs.</li>
<li>Successfully complete the steps on this web page,
to generate the certificate.</li>
<li>Run on the client (using sudo if needed):<br>
<span class="bold">asceds-service-reconfig -q -t</span><br>
to have the same services reconfigured with 
the new certificate.
Or wait for one more day for the services  to be reconfigured 
automatically by cron.</li>
</ul>
</p>
<p>
The procedure for initializing ASCEDS, 
when a new computer is installed or after OS upgrades:
<ul>
<li>Login with root/sudo rights on the client 
<?php echo $fullhostname ; ?>.</li>
<li>Install ASCEDS (if not installed already).</li>
<li>Run on the client (using sudo if needed):<br>
<span class="bold">asceds-init -s 
<?php echo $servername ; ?></span><br>
Correctly fill in the info  requested by asceds-init.</li>
<li>Successfully complete the steps on this web page,
to generate the certificate.</li>
<li>Run on the client (using sudo if needed):<br>
<span class="bold">asceds-services</span><br>
and pick which services will be reconfigured 
to use the new certificate. </li>
</ul>
</p>
<p> <span class="bold">
What to do:
</span>
<br>
<?php

if( $infotodo == 'ssh' ) {
   echo '<p>The action is performed live on the certificate manager.<br>';
   echo 'The result will be shown on this page, please wait for it.</p>';
   echo '<p>If no errors are shown and this is a fresh init, ';
   echo 'please run "asceds-services" ';
   echo 'as root on the client and configure services. '; 
   echo 'Otherwise, please run "asceds-service-reconfig -t" '; 
   echo 'as root on the client, ';
   echo 'or wait for one more day for the services ';
   echo 'to be reconfigured automatically by cron.</p>';
} elseif( $infotodo == 'cron' ) {
   echo '<p>A certificate propagate task was introduced in the queue ';
   echo 'of the certificate manager, and it cannot be canceled.</p>';
   echo '<p>After the suggested completion time passed, ';
   echo 'Please follow the last item in the scenarios above ';
   echo 'to complete the setup.</p>';
} elseif( $infotodo == 'badinput' ) {
   echo '<p>Request rejected! <br>';
   echo 'This is a sign of broken code or inconsistent client data. <br>';   
   echo '<span class="bold">Please contact the certificate manager\'s  ';
   echo 'administrator at <br>';
   echo '<a href="mailto:' . $adminemail . '">' . $adminemail . '</a><br>';
   echo 'to get things fixed soon.</span></p>';
} elseif( $infotodo == 'norwaccess' ) {
   echo '<p>Request rejected! <br>';
   echo 'Either the certificate manager does not have write access to ';
   echo 'asceds@' . $fullhostname . ', or the client was not ';
   echo 'initialized, and the ASCEDS cert.conf file is not available.<br>';
   echo 'Please fix the problem as instructed, then try again.</p>';
} elseif( $infotodo == 'lockedrequest' ) {
   echo '<p>Another request is pending for this host.<br>';
   echo 'To avoid race conditions, please wait until ';
   echo 'the queue is clear and try again in a few minutes.</p>';
}

?>

</aside>
</div>

<?php
include '../footer.php';
?>
</body>
</html>