<!DOCTYPE html>
<?php
include '../../etc/asceds.php';
include '../../etc/config.php';
include '../../etc/users.php';
$username = $_SERVER['REMOTE_USER'];
if (in_array('ALL', $authdomains[$username])) {
   $domains = $allauthdomains ;
} else {  
   $domains = $authdomains[$username];
} 
?>

<html>
  <head>
    <meta name="author" content="Florin Manolache">
    <title>ASCEDS Certificate edit @ <?php echo $unit; ?></title>
    <link rel="stylesheet" href="../css/cert.css">
  </head>

<body>

<?php
include '../header.php';
?>

<div id="main">

<article>
<?php
include 'navi.php';
?>

<p class="asceds">ASCEDS new certificate edit</p> 

<?php
include '../custom.php';
?>

<?php
echo "<p> Hello user " . $username . " </p>";
#print_r($domains);

# first checks and filtering of input
$validinput = 'yes';

# initialize infotodo variables
$infotodo = '';
$infotodo2 = '';

$ack = strtolower ( trim($_POST["ack"]) );
# tests and filters for hostname
$ack_00 = preg_replace( '/[^a-z0-9]/', '', $ack );
if( $ack_00 != $ack ) {
   echo '<br>Invalid characters in acknowledgement <br>';
   $validinput='';
   $ack = $ack_00;
} elseif( empty($ack) ) {
   echo '<br> Empty acknowledgement <br>';
   $validinput='';
}

$hostname = strtolower ( trim($_POST["hostname"]) );
# tests and filters for hostname
$hostname_00 = preg_replace( '/[^-.a-z0-9]/', '', $hostname );
if( $hostname_00 != $hostname ) {
   echo '<br>Invalid characters in host <br>';
   $validinput='';
   $hostname = $hostname_00;
} elseif( empty($hostname) ) {
   echo '<br> Empty host entry <br>';
   $validinput='';
}

$domain = strtolower ( trim($_POST["domain"]) );
# tests and filters for domain
$domain_00 = preg_replace( '/[^-.a-z0-9]/', '', $domain );
if( $domain_00 != $domain ) {
   echo '<br>Invalid characters in domain <br>';
   $validinput='';
   $domain = $domain_00;
} elseif( empty($domain) ) {
   echo '<br> Empty domain entry <br>';
   $validinput='';
} elseif( ! in_array($domain, $domains) ) {
   echo '<br> User ' . $username . ' is not authorized for domain ';
   echo $domain . '  <br>';
   $validinput='';
}

$fullhostname = $hostname . '.' . $domain;
# tests and filters for fullhostname
if(! filter_var($fullhostname, FILTER_VALIDATE_DOMAIN, FILTER_FLAG_HOSTNAME)) {
   echo '<br> Invalid full hostname format detected <br>';
   $validinput='';
}

$sans = strtolower ( trim($_POST["sans"]) );
# tests and filters for sans
if( ! empty($sans) ) {
   $sans_00 = preg_replace( '/[^-. ,a-z0-9]/', '', $sans );
   if( $sans_00 != $sans ) {
      echo '<br>Invalid characters in SANs <br>';
      $validinput='';
      $sans = $sans_00;
   } else {
      # split sans to an array 
      $sansarray = explode( ",", $sans);
      foreach ($sansarray as &$value) {
         $value = trim($value);
         if(! filter_var($value, FILTER_VALIDATE_DOMAIN, FILTER_FLAG_HOSTNAME)) {
            echo '<br> Invalid SAN entry "' . $value . '" detected in ';
            echo $sans . '.<br>';
            $validinput='';
         }
      }
      # print_r($sansarray);
   }
} else {
   $sansarray = array( );
}

$addhost = strtolower ( trim($_POST["addhost"]) );
# tests and filters for addhost
if(( ! empty($validinput)) && ( ! empty($addhost))) {
   $addhost_00 = preg_replace( '/[^-.a-z0-9]/', '', $addhost );
   if( $addhost_00 != $addhost ) {
      echo '<br>Invalid characters in added host!! <br>';
      echo 'No change recorded, please try again. <br>';
      $addhost = '';
   }
} else {
   $addhost = '';
}

$adddomain = strtolower ( trim($_POST["adddomain"]) );
# tests and filters for adddomain
if(( ! empty($validinput)) && ( ! empty($adddomain)) && ( in_array($adddomain, $domains))) {
   $adddomain_00 = preg_replace( '/[^-.a-z0-9]/', '', $adddomain );
   if( $adddomain_00 != $adddomain ) {
      echo '<br>Invalid characters in added domain!! <br>';
      echo 'No change recorded, please try again. <br>';
      $adddomain = '';
   }
} else {
   $adddomain = '';
}

# tests and filters for addfullhost
if( (! empty($adddomain)) && (! empty($addhost)) ) {
   # adding a hostname
   $addfullhost = $addhost . '.' . $adddomain ;
   if(filter_var($addfullhost, FILTER_VALIDATE_DOMAIN, FILTER_FLAG_HOSTNAME)) {
      # add new hostname to SAN list
      array_push($sansarray, $addfullhost);
      # make sure entries are unique
      $sansarray = array_unique($sansarray);
      $sans = implode( ', ', $sansarray);
   } else {
      echo '<br> Invalid full hostname to be added ' . $addfullhost . '<br>';
      echo 'No change made, please try again. <br>';
      $addfullhost = '';
   }
} elseif( (! empty($adddomain)) && (empty($addhost)) ) {
   # adding an A-record
   $addfullhost = $adddomain ;
   if(filter_var($addfullhost, FILTER_VALIDATE_DOMAIN)) {
      # add new hostname to SAN list
      array_push($sansarray, $addfullhost);
      # make sure entries are unique
      $sansarray = array_unique($sansarray);
      $sans = implode( ', ', $sansarray);
      # issue warning
      echo '<br><span class="bold"> Warning: A-record "' . $addfullhost;
      echo '" added to the SAN list. Check for DNS conflicts!!!</span><br>';
   } else {
      echo '<br> Invalid A-record to be added ' . $addfullhost . '<br>';
      echo 'No change made, please try again. <br>';
      $addfullhost = '';
   }
} else {
   $addfullhost = '';
}

$delhost = strtolower ( trim($_POST["delhost"]) );
# tests and filters for delhost
if( (! empty($delhost)) && ( ! empty($validinput))) {
   if(filter_var($delhost, FILTER_VALIDATE_DOMAIN, FILTER_FLAG_HOSTNAME)) {
      # delete the hostname from SAN list
      $sans = preg_replace( '/' . $delhost . ',*\s*/', '', $sans );
      $sans = preg_replace( '/,\s*$/', '', $sans );
      if( ! empty($sans) ) {
         $sansarray = explode( ",", $sans);
         foreach ($sansarray as &$value) {
            $value = trim($value);
            if(! filter_var($value, FILTER_VALIDATE_DOMAIN, FILTER_FLAG_HOSTNAME)) {
               echo '<br> Invalid SANs entry "' . $value . '" detected in ';
               echo $sans . '.<br>';
               $validinput='';
            }
         }
      } else {
         $sansarray = array( );
      }
   } else {
      echo '<br> Invalid hostname to be deleted ' . $delhost . '<br>';
      echo 'No change recorded, please try again. <br>';
      $delhost = '';
   }
} else {
   $delhost = '';
}

# if everything checked out, go for editing
if( ! empty($validinput)) {

   echo '<p class="solidb">';
   echo 'Hostname: ' . $fullhostname . '<br>';
   echo 'Current SANs: ' . $sans . '<br>';
   echo 'SANs hostname count: ' . count($sansarray) . '<br>';
   echo '</p>';
   
   echo '<p>If changes need to be made to the SAN list, ';
   echo 'please proceed using the form below.<br>';
   echo 'The form will reload until all the changes are included.<br>';
   echo '<form action="edit_cert.php" method="post">';
   echo '<input type="hidden" name="hostname" value="' . $hostname . '">';
   echo '<input type="hidden" name="domain" value="' . $domain . '">';
   echo '<input type="hidden" name="sans" value="' . $sans . '">';
   echo '<input type="hidden" name="ack" value="' . $ack . '">';

   echo 'Host to <span class="bold">add</span> to SAN list: '; 
   echo '<input type="text" name="addhost"> . ';
   echo '<select name="adddomain">';
   echo '<option value="" selected>Select a Domain</option>';
   foreach ($domains as &$value) {
      echo '<option value="' . $value . '">' . $value . '</option>'; }
   echo '</select> <br>';
   
   if( count($sansarray) > 0 ) {
      # if sansarray has any elements:
      echo '<br>Host to <span class="bold">delete</span> from SAN list: '; 
      echo '<select name="delhost">';
      echo '<option value="" selected>Select Hostname to Remove</option>';
      foreach ($sansarray as &$value) {
         echo '<option value="' . $value . '">' . $value . '</option>'; }
      echo '</select> <br>';
   } else {
      # else nothing to delete
      echo '<input type="hidden" name="delhost" value="">';
   }
   echo '<br><input type="submit" value="Submit Change">';
   echo '</form> </p> <hr>';

   echo '<p>If SAN list looks good, the certificate can be created. ';
   echo '<br> To start fresh with this host: ';
   echo '<a href="host_check.php?client_type=unmanaged'; 
   echo '&hostname=' . $hostname;
   echo '&domain=' . $domain . '">' . $fullhostname . '</a>';
   echo '<br>To try a different host, go back to ';
   echo '<a href="index.php">start page</a></p>';
   echo '<p><span class="bold">Warning:</span><br>';
   echo 'The certificate will be renewed automatically on this ';
   echo 'certificate manager 30 days before expiration. ';
   echo 'An email messages about renewal will be send to: ';
   echo $username . '</p>';

   echo '<form action="request_cert.php" method="post">';
   echo '<input type="hidden" name="hostname" value="' . $hostname . '">';
   echo '<input type="hidden" name="domain" value="' . $domain . '">';
   echo '<input type="hidden" name="sans" value="' . $sans . '">';
   echo '<input type="hidden" name="ack" value="' . $ack . '">';
   echo '<label for="selector">Encryption type: </label>';
   echo '<select id="enc" name="enc">';
   echo '<option value="rsa" selected>RSA</option>';
   echo '<option value="ecc">ECC</option>';
   echo '</select> <p>';
   echo '<input type="submit" value="Generate Certificate">';
   echo ' --> <span class="bold">Please WAIT</span> ';
   echo 'for the certificate to be generated after placing the request. ';
   echo 'It may take a minute or two.</p>';
   echo '</form> </p>';

   $infotodo='carryon';
} else {
   echo 'Page got malformed input.<br>';
   echo 'Please follow instructions on the right';
   $infotodo='badinput';
}  

?>

</article>

<aside>

<p> <span class="bold">
What to do:
</span>
<br>
<?php

if( $infotodo == 'carryon' ) {
   echo '<p>Examine the hostname info and the SAN list.<br>';
   echo 'Cycle through the changes until everything looks good.<br>';
   echo 'Then create the certificate. </p>';
   echo '<p>The hostnames included in the SAN list '; 
   echo 'must have DNS records, ';
   echo 'and must resolve to the same IP address as the server hostname. ';
   echo 'The ASCEDS software and this web interface does not check ';
   echo 'and does not enforce this condition.<br>';
   echo '<span class="bold">For avoiding conflicts, please ALWAYS ';
   echo 'check the DNS records before adding a hostname to the SAN list !!!';
   echo '</span></p>';
   echo '<p>To add an A-record to the SAN list, please leave the ';
   echo 'host part of the input empty, and select only the domain.</p>'; 

} elseif( $infotodo == 'badinput' ) {
   echo '<br>Request rejected! <br>';
   echo 'This is a sign of broken code or inconsistent client data. <br>';   
   echo '<span class="bold">Please contact the certificate manager\'s  ';
   echo 'administrator at <br>';
   echo '<a href="mailto:' . $adminemail . '">' . $adminemail . '</a><br>';
   echo 'to get things fixed soon.</span>';
}

?>

</aside>
</div>

<?php
include '../footer.php';
?>
</body>
</html>