<!DOCTYPE html>
<?php
include '../../etc/asceds.php';
include '../../etc/config.php';
include '../../etc/users.php';
$username = $_SERVER['REMOTE_USER'];
$servername = $_SERVER['SERVER_NAME'];
if (in_array('ALL', $authdomains[$username])) {
   $domains = $allauthdomains ;
} else {  
   $domains = $authdomains[$username];
} 
?>

<html>
  <head>
    <meta name="author" content="Florin Manolache">
    <title>ASCEDS Certificate inquiry @ <?php echo $unit; ?></title>
    <link rel="stylesheet" href="../css/cert.css">
  </head>

<body>

<?php
include '../header.php';
?>

<div id="main">
<article>
<?php
include 'navi.php';
?>

<p class="asceds">ASCEDS certificate inquiry</p>

<?php
include '../custom.php';
?>

<?php
echo "<p> Hello user " . $_SERVER['REMOTE_USER'] . '</p>' ;
#print_r($domains);

# first checks and filtering of input
$validhostname='yes';

# initialize infotodo variables
$infotodo = '';
$infotodo2 = '';

$inputhost = strtolower ( trim($_GET["hostname"]) );
# tests and filters for hostname
$inputhost_00 = preg_replace( '/[^-.a-z0-9]/', '', $inputhost );
if( $inputhost_00 != $inputhost ) {
   echo '<br>Invalid characters in host <br>';
   $validhostname='';
   $inputhost = $inputhost_00;
} elseif( empty($inputhost) ) {
   echo '<br> Empty host entry <br>';
   $validhostname='';
}

$inputdomain = strtolower ( trim($_GET["domain"]) );
# tests and filters for domain
$inputdomain_00 = preg_replace( '/[^-.a-z0-9]/', '', $inputdomain );
if( $inputdomain_00 != $inputdomain ) {
   echo '<br>Invalid characters in domain <br>';
   $validhostname='';
   $inputdomain = $inputdomain_00;
} elseif( empty($inputdomain) ) {
   echo '<br> Empty domain entry <br>';
   $validhostname='';
}

$client_type = strtolower ( trim($_GET["client_type"]) );
# tests and filters for client_type
$client_type_00 = preg_replace( '/[^a-z0-9]/', '', $client_type );
if( $client_type != $client_type_00 ) {
   echo '<br>Invalid characters in client_type <br>';
   $client_type='';
}

$fullhostname = $inputhost . '.' . $inputdomain;
# tests and filters for fullhostname
if(! filter_var($fullhostname, FILTER_VALIDATE_DOMAIN, FILTER_FLAG_HOSTNAME)) {
   echo '<br> Invalid full hostname format detected <br>';
   $validhostname='';
}

$certdir = $ascedshomedir . '/' . $fullhostname;
$certfile = $certdir . '/cert.pem';
$certconffile = $ascedshomedir . '/' . $fullhostname . '_cert.conf';
$sans = '';
$hascert='';
if(! empty($validhostname)) {
   if (in_array($inputdomain, $domains)) {
      echo '<p class="bold">Analyzing certificate for client: ' . $fullhostname . '</p>';
      # initialize change_type (default empty)
      $change_type='';
      if (! is_dir($certdir)) {
         # maybe it is in SAN list for anther hostname
         echo '<p> Hostname ' . $fullhostname . ' is new to this certificate manager. </p>';
         echo '<p> Searching the existing SANs ... ';
         $cmd = 'grep -aisl "[=, \'\"]' . str_replace('.', '\.', $fullhostname) . '\b" ' . $ascedshomedir . '/*_cert.conf';
         # echo '<br> grep command: ' . $cmd . '<br>';
         $matchingfiles = shell_exec($cmd);
         $matchinghosts = preg_replace('/_cert.conf/', '', $matchingfiles);
         $matchinghosts = preg_replace('/.*\//', '', $matchinghosts);
         $matchinghostsnumber = substr_count( $matchinghosts, "\n" );

         if ( $matchinghostsnumber < 1 ) {
            # no SAN matches
            echo 'none found <br>';
            # continue the process
            $next = 'yes';
            $infotodo = 'newhost';
         } elseif ( $matchinghostsnumber < 2 ) {
            # SAN for one host matches
            $matchinghosts = trim( $matchinghosts );
            preg_match("/^(.*?)\.(.*)/", $matchinghosts, $matchingfqdn);
            
            # offer link for hostname
            echo 'hostname found in SANs for host: ';
            echo '<a href="host_check.php?client_type=' . $client_type; 
            echo '&hostname=' . $matchingfqdn[1];
            echo '&domain=' . $matchingfqdn[2];
            echo '">' .  $matchinghosts . '</a>';
            echo '<br>';

            
            if ( $matchinghosts != $fullhostname ) {
               # do not continue new key request
               $next = '';
               $infotodo = 'hostin1sans';
            } else {
               # cert.conf file is there, but no certificates yet;
               # can safely continue generation   
               $next = 'yes';
               $infotodo = 'confonly';
            }
         } else {
            # SANs for multiple hosts match, broken code or inconsistent data
            echo 'hostname found in ' . $matchinghostsnumber . ' SANs:<br>' 
                 . nl2br($matchinghosts);
            # do not continue new key request
            $next = '';
            $infotodo = 'hostinmultsans';
         }
         echo '</p>';
      }
      elseif (! is_file($certfile)) {
         echo '<p> Hostname ' . $fullhostname . ' does not have  a certificate yet </p>';
         # should never get here -- corrupted asceds state, ask for help
         $next = '';
         $infotodo = 'missingcert';
      }
      else {
         $hascert='yes';
         # extract data from certificate and list it
         echo 'Hostname ' . $fullhostname . ' already has a certificate';
         echo '<p class="solidb">';
         echo "Validity:<br>";
         $cmd = 'openssl x509 -dates -noout < ' . $certfile;
         echo nl2br(shell_exec($cmd));
         echo '</p>';
         echo '<p class="solidb">';
         $cmd = 'openssl x509 -noout -ext subjectAltName < ' . $certfile;
         $sans = str_replace("DNS:", "", shell_exec($cmd));
         echo nl2br($sans);
         echo '</p>';
         $sans = preg_replace('/^.+\n/', '', $sans);
         $sans = preg_replace('/' . $fullhostname . ',*\s*/', '', $sans);
         $sans = preg_replace('/,\s*$/', '', $sans);
         # echo 'sans = ' . $sans . '<br>';
         
         # we don't want to change the client status (managed vs unmanaged)
         if ( is_file($certconffile) ) {
            # extract NO_ASCEDS status from the cert.conf file
            $cmd = 'NO_ASCEDS="" ; . ' . $certconffile . '; echo "${NO_ASCEDS}"';
            $not_managed = trim(shell_exec($cmd));
            # enforce NO_ASCEDS managed status from config file if managed client
            if( empty($not_managed)) {
               if ( $client_type == 'unmanaged' ) {
                  # flag the client type change
                  $change_type='tonotmanaged';
                  # echo '<p class="bold"> This is a managed ASCEDS client. ';
                  # echo 'Please use ASCEDS for propagating the certificate.<br>';
                  # echo 'Reverting request to ASCEDS managed !!! </p>';
                  # $client_type = 'asceds';
                  $infotodo2 = 'badclienttype';
               }
            } else {
               # if not managed
               if ( $client_type == 'asceds' ) {
                  # flag the client type change
                  $change_type='tomanaged';
                  $infotodo2 = 'badclienttype';
               }

               if( $client_type == 'unmanaged' ) {
                  # find cert_id
                  $cmd = 'ASCEDS_CERT_ID="" ; . ' . $certconffile . '; echo "${ASCEDS_CERT_ID}"';
                  $cert_id=trim(shell_exec($cmd));
                  if(! empty($cert_id) ) {
                      # offer cert for download        
                      echo '<p>Download the certificate files:</p>';
                      echo '<p class="solidb">';
                      echo '<span class="bold">Existing certificate:</span><br>';
                      echo'Private key (keep it private): ';
                      echo '<a href="keys/' . $cert_id . '/privkey.pem" ';
                      echo 'download>privkey.pem</a><br>';
                      echo'Certificate chain (to be used with services): ';
                      echo '<a href="keys/' . $cert_id . '/fullchain.pem" ';
                      echo 'download>fullchain.pem</a><br>';
                      echo'Certificate (useless but informative): ';
                      echo '<a href="keys/' . $cert_id . '/cert.pem" ';
                      echo 'download>cert.pem</a>';
                      if( file_exists( 'keys/' . $cert_id . '/combined.pfx' ) ) {
                         echo'<br> Certificate and key packed for printers: ';
                         echo '<a href="keys/' . $cert_id . '/combined.pfx" ';
                         echo 'download>combined.pfx</a> <br>';
                         echo ' &nbsp; &nbsp; &nbsp; ';
                         echo ' <em> ** the password for the pfx file is ';
                         echo ' the login name of the requester. </em>';
                      }
                      echo '</p>';
                  }
               }            
            }                   
         } else {
            # certificates exist but the cert.conf file is missing
            echo '<p class="bold"> Old certificate exist, but ';
            echo 'configuration file ' . $certconffile ;
            echo ' is missing </p>';
            $infotodo2 = 'missingcertconf';            
         }
         $next = 'yes';
         $infotodo = 'currentclient';
      }
      echo '<hr><p>Continue to create a new certificate:</p>';
      if ( ($client_type == 'asceds') && (! empty($next)) ) {
         echo '<form action="asceds_cert.php" method="post">';
         if( $change_type == 'tomanaged' ) {
            echo '<input type="checkbox" name="ack" value="' . $change_type . '" required> ';
            echo 'I am changing the client type ';
            echo '<span class="bold">from unmanaged to managed</span>.<br>'; 
            echo 'I will initialize and configure ASCEDS on this client ';
            echo 'as instructed on the next pages.<br><br>';
         } else {
            echo '<input type="hidden" name="ack" value="same">';
         }
         echo '<input type="hidden" name="hostname" value="' . $inputhost . '">';
         echo '<input type="hidden" name="sans" value="' . $sans . '">';
         echo '<input type="hidden" name="domain" value="' . $inputdomain . '">';
         echo '<input type="submit" value="Create and Propagate">';
         echo ' --> <span class="bold">Please WAIT</span> ';
         echo 'for the certificate to be created and propagated ';
         echo 'after placing the request. ';
         echo 'It may take a minute or two. ';
         echo '</form>';
      } elseif ( ($client_type == 'unmanaged') && (! empty($next)) ) {
         echo '<form action="edit_cert.php" method="post">';
         if( $change_type == 'tonotmanaged' ) {
            echo '<input type="checkbox" name="ack" value="' . $change_type . '" required>';
            echo 'I am changing the client type ';
            echo '<span class="bold">from managed to unmanaged</span>.<br>';
            echo 'I will <span class="bold">be responsible</span> ';
            echo ' for downloading and installing ';
            echo 'the certificate files and any future updates.<br>';
            echo 'I agree to be <span class="bold">notified by email</span> at ';
            echo $username . ' when updates are available.<br><br>';
         } else {
            echo '<input type="hidden" name="ack" value="same">';
         }
         echo '<input type="hidden" name="hostname" value="' . $inputhost . '">';
         echo '<input type="hidden" name="domain" value="' . $inputdomain . '">';
         echo '<input type="hidden" name="sans" value="' . $sans . '">';
         echo '<input type="hidden" name="addhost" value="">';
         echo '<input type="hidden" name="adddomain" value="">';
         echo '<input type="hidden" name="delhost" value="">';
         echo '<input type="submit" value="Next to Create/Renew">';
         echo '</form>';
      } elseif ( empty($next) ) {
         echo '<span class="bold">Request breaks data consistency !!! </span> <br>';
         echo 'Please see  the instructions on the right, 
               or <a href="index.php">go back</a> and try again';
      } else {
         echo 'Unknown client type: ' . $client_type . ' <br>';
         echo 'Unspecified action to be completed. <br>';
         echo '<a href="index.php">Go back</a> and try again';
      }

      echo '<br>';      
      if( ! empty($hascert) ) {
         # can revoke cert
         echo '<hr><p><form action="revoke_cert.php" method="post">';
         echo '<input type="hidden" name="hostname" value="' . $inputhost . '">';
         echo '<input type="hidden" name="domain" value="' . $inputdomain . '">';
         echo '<input type="hidden" name="sans" value="' . $sans . '">';
         echo 'Revoking the certificate ';
         echo '<span class="bold"> will completely remove all the certificate files,</span>';
         echo ' no recovery is possible.<br>';
         echo 'For changing the encryption type of an existing valid certificate, ';
         echo 'it needs to revoked and re-created.<br>';
         echo 'Are you sure that you want to revoke? Really sure?<br>';
         echo '<input type="submit" value="Revoke"><br>';
         echo '<span class="bold">Please WAIT</span> ';
         echo 'for the certificate to be revoked after placing this request. ';
         echo 'It may take a minute or two. ';
         echo '</form></p>';
      }
   } else {
      echo 'User ' . $username . ' is not authorized to get certificates for ';
      echo 'domain <span class="bold">' . $inputdomain . '</span> <br>';
      echo 'To get authorized, please contact the certificate manager\'s ';
      echo 'administrator at <br>';
      echo '<a href="mailto:' . $adminemail . '">' . $adminemail . '</a>';
      $infotodo = 'baddomain';
   }
} else {
  echo 'Malformed hostname input ' . $fullhostname . '<br>';
  $infotodo='badhostname';
}  
?>
</article>

<aside>

<?php
if( $client_type == 'asceds' ) {
   if( $infotodo == 'currentclient' ) {
      echo '<p>';
      echo 'The procedure for changing the certificate configuration, '; 
      echo 'e.g. when virtual server names are added or removed in the SAN list:';
      echo '<ul>';
      echo '<li>Login with root/sudo rights on the client ';
      echo $fullhostname ;
      echo '.</li>';
      echo '<li>Run on the client (using sudo if needed):<br>';
      echo '<span class="bold">asceds-sans-update</span><br>';
      echo 'Add or remove SAN values to suit your needs.</li>';
      echo '<li>Successfully complete the steps on this web page, ';
      echo 'to generate the certificate.</li>';
      echo '<li>Run on the client (using sudo if needed):<br>';
      echo 'asceds-service-reconfig -q -t<br> ';
      echo 'to have the same services reconfigured with ';
      echo 'the new certificate. ';
      echo 'Or wait for one more day for the services  to be reconfigured ';
      echo 'automatically by cron.</li>';
      echo '</ul>';
      echo '</p>';
   }
   echo '<p>';
   echo 'The procedure for initializing ASCEDS, '; 
   echo 'when a new computer is installed or after OS upgrades:';
   echo '<ul>';
   echo '<li>Login with root/sudo rights on the client ';
   echo $fullhostname ;
   echo '.</li>';
   echo '<li>Install ASCEDS (if not installed already).</li>';
   echo '<li>Run on the client (using sudo if needed):<br>';
   echo '<span class="bold">asceds-init [-s <cert_manager>] ';
   echo $servername ; 
   echo '</span><br>';
   echo 'Correctly fill in the info  requested by asceds-init.</li>';
   echo '<li>Successfully complete the steps on this web page, ';
   echo 'to generate the certificate.</li>';
   echo '<li>Run on the client (using sudo if needed):<br>';
   echo 'asceds-services<br>';
   echo 'and pick which services will be reconfigured ';
   echo 'to use the new certificate. </li>';
   echo '</ul>';
   echo '</p>';
}
?>

<p> <span class="bold">
What to do:
</span>
<br>
<?php

if( $infotodo == 'badhostname' ) {
   echo 'Malformed hostname ' . $fullhostname;
   echo '<br>Request rejected! <br>';
   echo '<br> Please <a href="index.php">go back</a> and try again.';

} elseif( $infotodo == 'baddomain' ) {
   echo 'Unauthorized domain ' . $inputdomain;
   echo '<br>Request rejected! <br>';
   echo '<br> Please <a href="index.php">go back</a> and try again.';
   
} elseif( $infotodo == 'newhost' ) {
   echo 'Requesting certificate for a new hostname. <br>';
   echo 'Please follow the steps from the initializing procedure above.<br>';
   echo 'Continue to the next page for requesting a new certificate, ';
   echo 'or <a href="index.php">go back</a> and try a new host name.';
   
} elseif( $infotodo == 'hostin1sans' ) {
   echo 'This hostname is is the SAN list of ' . $matchinghosts;
   echo '<br>Request rejected! <br>';
   echo 'However, you can request a new certificate for ';
   echo '<a href="host_check.php?client_type=' . $client_type; 
   echo '&hostname=' . $matchingfqdn[1];
   echo '&domain=' . $matchingfqdn[2];
   echo '">' .  $matchinghosts . '</a>';
   
} elseif( $infotodo == 'confonly' ) {
   echo 'The hostname ' . $matchinghosts . ' has a cert.conf file ' ;
   echo 'but no certificates were found. <br>' ;
   echo 'This typically happens if the ACME server times out. <br>' ;
   echo 'Please continue generating the certificate, or try again later. <br>' ;

} elseif( $infotodo == 'hostinmultsans' ) {   
   echo 'This hostname is is the SAN list of multiple hosts: <br>';
   echo $matchinghosts . '<br>';
   echo 'This is a sign of broken code or inconsistent client data. <br>';   
   echo '<span class="bold">Please contact the certificate manager\'s  ';
   echo 'administrator at <br>';
   echo '<a href="mailto:' . $adminemail . '">' . $adminemail . '</a><br>';
   echo 'to get things fixed soon.</span>';
   
} elseif(  $infotodo == 'missingcert' ) {  
   echo 'The ASCEDS directory of ' . $fullhostname;
   echo ' does not contain a certificate. <br>';
   echo 'This may be a sign of broken code or inconsistent client data. <br>';   
   echo 'Please continue with the request.';
   
} elseif(  $infotodo == 'currentclient' ) {
   echo 'This is an existing client.<br>';
   echo 'Please examine the old certificate info ';
   echo 'to check if renewal is needed.<br>';
   echo 'If the client was just reinstalled, ASCEDS needs ';
   echo 'to be initialized. ';
   echo 'Please follow the steps from the initializing procedure above.<br>';
   echo 'If the SAN list needs to be modified, ';
   echo 'please follow the steps from changing configuration procedure above.<br>';

   if( $infotodo2 == 'badclienttype' ) { 
      if( $change_type == 'tonotmanaged' ) {
         echo '<br>The certificate configuration file of ' . $fullhostname ;
         echo ' shows it as a currently <span class="bold">managed</span> ';
         echo 'ASCEDS client. <br>';
         echo 'Changing client type with ASCEDS still installed and ';
         echo 'functional on the client, can lead to configuration ';
         echo 'inconsistencies or service malfunction.<br>';
         echo 'If the change is intentional, ';
         echo 'please check the acknowledgement and continue.<br>';
         echo 'Otherwise, <a href="index.php">go back</a> ';
         echo 'to the entry page and use the managed client type.<br>';
      } elseif( $change_type == 'tomanaged' ) { 
         echo '<br>The certificate configuration file of ' . $fullhostname;
         echo ' shows it as a currently <span class="bold">unmanaged</span> ';
         echo 'ASCEDS client. <br>';
         echo 'Changing client type will work only if ASCEDS is installed ';
         echo 'and initialized on the client.<br>';
         echo 'Instructions for doing that will be provided ';
         echo 'on the next pages.<br>';
         echo 'If the change is intentional, ';
         echo 'please check the acknowledgement and continue.<br>';
         echo 'Otherwise, <a href="index.php">go back</a> ';
         echo 'to the entry page and use the unmanaged client type.<br>';
      }          
   } elseif( $infotodo2 == 'missingcertconf' ) { 
      echo '<br>The ASCEDS certificate configuration file of ' . $fullhostname ;
      echo ' is missing. <br>';
      echo 'This may be a sign of broken code or inconsistent client data. <br>';   
      
   }
   
   if( ! empty($hascert) ) {
      echo '<p><span class="bold">Revoking a certificate:</span><br>';
      echo 'This action will make the certificate invalid and will '; 
      echo '<span class="bold">delete</span>'; 
      echo ' the certificate files.<br>'; 
      echo 'There is no way to restore the validity unless a new certificate'; 
      echo ' is created for this host. </p>';
   }

   echo '<p>Continue with the request ';
   echo 'for generating a new certificate, ';
   if( ! empty($hascert) ) {
      echo 'or for revoking this certificate, <br>';
   }
   echo 'or <a href="index.php">go back</a> to the entry page, ';
   echo 'and try a new hostname.</p>';

} else { 
   
   echo 'This text should never be listed. <br>';
   echo '<span class="bold">Please contact the certificate manager\'s  ';
   echo 'administrator at <br>';
   echo '<a href="mailto:' . $adminemail . '">' . $adminemail . '</a><br>';
   echo 'to get things fixed soon.</span>';

}

?>

</aside>
</div>

<?php
include '../footer.php';
?>
</body>
</html>