<!DOCTYPE html>
<?php
include '../../etc/asceds.php';
include '../../etc/config.php';
include '../../etc/users.php';
$username = $_SERVER['REMOTE_USER'];
if (in_array('ALL', $authdomains[$username])) {
   $domains = $allauthdomains ;
} else {  
   $domains = $authdomains[$username];
}
?>

<html>
  <head>
    <meta name="author" content="Florin Manolache">
    <title>ASCEDS Certificate management @ <?php echo $unit; ?></title>
    <link rel="stylesheet" href="../css/cert.css">
  </head>

<body>

<?php
include '../header.php';
?>

<div id="main">

<article>
<p class="asceds">ASCEDS certificate management system</p>

<?php
include '../custom.php';
?>

<?php
echo "Hello user " . $username ;

# initialize infotodo variables
$infotodo = '';
$infotodo2 = '';

echo '<p class="solidb">';
echo '<span class="bold"> All domains available: </span> <br>';
foreach ($allauthdomains as &$value) {
   echo $value . '<br>'; }
echo '</p>';
echo '<p class="solidb">';
echo '<span class="bold"> Your domains: </span> <br>';
foreach ($domains as &$value) {
   echo $value . '<br>'; }
echo '</p>';
?>

<form action="host_check.php" method="get">
<p>
<span class="bold"> Client type: </span> <br>
<input type="radio" name="client_type" value="asceds" required> 
Managed client with ASCEDS configured<br>
<input type="radio" name="client_type" value="unmanaged"> 
Unmanaged: Only generate certificate
</p>
<p>

<span class="bold"> Host: </span> 
<input type="text" name="hostname" required> .
<?php
echo '<select name="domain" required>';
echo '<option value="" selected disabled hidden>Select a Domain</option>';
foreach ($domains as &$value) {
   echo '<option value="' . $value . '">' . $value . '</option>'; }
echo '</select>';
?>
</p>
<p>
<input type="submit" value="Next">
</p>
</form>
</article>

<aside>

<img src="../figs/ASCEDSarch.png" alt="ASCEDS Architecture"
style="width: 20vw; min-width: 200px;">

<?php 
if (file_exists('../public/asceds.pdf')) {
echo '<span class="alignright">';
echo '<a href="../public/asceds.pdf"class="button" download>';
echo 'ASCEDS whitepaper</a>';
echo '</span>';
}
?>

<p> <span class="bold"> ASCEDS architecture: </span>
an ASCEDS site consists of a certificate manager which is 
authorized to get certificates for a set of domains, 
based on secret tokens issued by a CA.<br>
The certificate manager has three kinds of clients:
<ul>
<li> <span class="bold">fully managed: </span> 
the certificate update process happens automatically;
<li><span class="bold">privately managed: </span>
client needs to be put in full ASCEDS access mode to
propagate cert files (e.g. pi-kvm);
<li> <span class="bold">unmanaged: </span>
no ASCEDS installed on the client; cert files and updates are propagated 
by hand by the sysadmin of the client (e.g. NAS, printer, switch,
Windows/MacOS);
</ul>
</p>

<p> <span class="bold">
Client type:
</span>
For <span class="bold">unmanaged</span> clients, 
certificate files are generated and offered for download.
For <span class="bold">managed</span> clients, 
certificate files are generated and propagated to the client.
Instructions to facilitate the process are offered on the 
proper page.
The previously <span class="bold">managed</span> 
clients will not generate 
<span class="bold">unmanaged</span> certificates.
</p>

<p> <span class="bold"> Your domains: </span>
Domains which can be used to create certificates by the current user.
For requesting to be authorized for more domains, 
please contact the certificate manager's administrator<?php 
if (! empty($adminemail)) {
echo ' at <a href="mailto:' . $adminemail . '">' . $adminemail . '</a>';
}
?>.
</p>

<p> <span class="bold">
Hostname: </span> 
DNS name of the server 
using the certificate, including host and domain.
</p>

</aside>
</div>

<?php
include '../footer.php';
?>

</body>
</html>