<!DOCTYPE html>
<?php
include '../../etc/asceds.php';
include '../../etc/config.php';
include '../../etc/users.php';
$username = $_SERVER['REMOTE_USER'];
if (in_array('ALL', $authdomains[$username])) {
   $domains = $allauthdomains ;
} else {  
   $domains = $authdomains[$username];
} 
?>

<html>
  <head>
    <meta name="author" content="Florin Manolache">
    <title>ASCEDS Certificate revoke @ <?php echo $unit; ?></title>
    <link rel="stylesheet" href="../css/cert.css">
  </head>

<body>

<?php
include '../header.php';
?>

<div id="main">

<article>
<?php
include 'navi.php';
?>

<p class="asceds">ASCEDS revoke certificate</p> 

<?php
include '../custom.php';
?>

<?php
echo "<p> Hello user " . $username . " </p>";
#print_r($domains);

# initialize infotodo variables
$infotodo = '';
$infotodo2 = '';

# first checks and filtering of input
$validinput = 'yes';

$hostname = strtolower ( trim($_POST["hostname"]) );
# tests and filters for hostname
$hostname_00 = preg_replace( '/[^-.a-z0-9]/', '', $hostname );
if( $hostname_00 != $hostname ) {
   echo '<br>Invalid characters in host <br>';
   $validinput='';
   $hostname = $hostname_00;
} elseif( empty($hostname) ) {
   echo '<br> Empty host entry <br>';
   $validinput='';
}

$domain = strtolower ( trim($_POST["domain"]) );
# tests and filters for domain
$domain_00 = preg_replace( '/[^-.a-z0-9]/', '', $domain );
if( $domain_00 != $domain ) {
   echo '<br>Invalid characters in domain <br>';
   $validinput='';
   $domain = $domain_00;
} elseif( empty($domain) ) {
   echo '<br> Empty domain entry <br>';
   $validinput='';
} elseif( ! in_array($domain, $domains) ) {
   echo '<br> User ' . $username . ' is not authorized for domain ';
   echo $domain . '  <br>';
   $validinput='';
}

$fullhostname = $hostname . '.' . $domain;
# tests and filters for fullhostname
if(! filter_var($fullhostname, FILTER_VALIDATE_DOMAIN, FILTER_FLAG_HOSTNAME)) {
   echo '<br> Invalid full hostname format detected <br>';
   $validinput='';
}

$sans = strtolower ( trim($_POST["sans"]) );
# tests and filters for sans
$sans_00 = preg_replace( '/[^-. ,a-z0-9]/', '', $sans );
if( $sans_00 != $sans ) {
   echo '<br>Invalid characters in SANs <br>';
   $validinput='';
   $sans = $sans_00;
} 

if( ! empty($validinput)) {

   echo '<p>';
   echo 'Hostname: ' . $fullhostname . '<br>';
   echo 'SANs: ' . $sans . '<br>';
   echo '</p>';
   
   # prevent race conditions
   $revokeconffile = $certqueuedir . '/' . $fullhostname . '.rev';
   $requestconffile = $certqueuedir . '/' . $fullhostname . '.cert';
   $propagateconffile = $certqueuedir . '/' . $fullhostname . '.asceds';
   if( is_file($revokeconffile) ) {
      echo '<p>A revoke request is already in the queue for ' . $fullhostname;
      echo '<br>' . nl2br( file_get_contents($revokeconffile) );
      echo '<br>No further action is needed.</p>';
      $infotodo='lockedrequest';
   } elseif( is_file($requestconffile) ) {
      echo '<p>A new certificate request is already in the queue for ' . $fullhostname;
      echo '<br>' . nl2br( file_get_contents($requestconffile) );
      echo '<br>You can revoke it after it is generated.<br>';
      echo 'Please try again later</p>';
      $infotodo='lockedrequest';
   } elseif( is_file($propagateconffile) ) {
      echo '<p>A propagate request is already in the queue for ' .  $fullhostname;
      echo '<br>' . nl2br( file_get_contents($propagateconffile) );
      echo '<br>Please wait until it is completed.</p>';
      $infotodo='lockedrequest';
   } else {
      $revfile = fopen($revokeconffile, "w") or 
                 die('Unable to open file!' . $revokeconffile); 
      $timeline = 'REQUEST_DATE="' . date("m/d/Y H:i:s") . '"
';
      $hostline = 'CLIENT_DOMAIN_NAME="' . $fullhostname . '"
';
      $requestedby = 'REQUESTED_BY="' . $username . '"
';
      fwrite($revfile, $timeline);
      fwrite($revfile, $hostline);
      fwrite($revfile, $requestedby);
      fclose($revfile);

      if( $revokemode == 'cron' ) {
         echo '<p> Your request was recorded and queued.<br>';
         echo 'It will be executed in less than ' . $revoketime . '.</p>';
         $infotodo='cron';  
   
      } elseif( $revokemode == 'ssh' ) {
         echo '<p class="solidb">';
         $cmd = $sshcommand . '"' . $pathtoexec . '/asceds-web-unmanaged -q -r -c '
                . $fullhostname . '"';
         echo nl2br( shell_exec($cmd) ) . '</p>';
         $infotodo='ssh';
      } else {
         echo '<p class="bold">Unknown revoke mode "' . $revokemode . '"</p>';
         $infotodo2='badinput';
      }
   }
} else {
   echo 'Page got malformed input.<br>';
   echo 'Please follow instructions on the right';
   $infotodo='badinput';
}  
?>
</article>

<aside>

<p> <span class="bold">
What to do:
</span>
<br>
<?php

if( $infotodo == 'ssh' ) {
   echo '<p>The action is performed live on the certificate manager.<br>';
   echo 'The result will be shown on this page, please wait for it.</p>';
} elseif( $infotodo == 'cron' ) {
   echo '<p>A certificate revoke task was introduced in the queue ';
   echo 'of the certificate manager, and it cannot be canceled.<br>';
   echo 'There is nothing else to be done at this moment.</p>';
} elseif( $infotodo == 'badinput' ) {
   echo '<br>Request rejected! <br>';
   echo 'This is a sign of broken code or inconsistent client data. <br>';   
   echo '<span class="bold">Please contact the certificate manager\'s  ';
   echo 'administrator at <br>';
   echo '<a href="mailto:' . $adminemail . '">' . $adminemail . '</a><br>';
   echo 'to get things fixed soon.</span>';
} elseif( $infotodo == 'lockedrequest' ) {
   echo '<p>Another request is pending for this host.<br>';
   echo 'To avoid race conditions, please wait until ';
   echo 'the queue is clear and try again in a few minutes.</p>';
}
?>

</aside>
</div>

<?php
include '../footer.php';
?>
</body>
</html>